
import ready from 'Utils/documentReady.js';

ready(function() {
    const bgSliderWrapper = document.querySelector('.bg-sliders');

    if (bgSliderWrapper && window.getComputedStyle(bgSliderWrapper).display != 'none') {
      const bgSliders = document.querySelectorAll('.bg-slider');

      if (bgSliders.length > 0) {
        const sldierDuration = parseInt(window.getComputedStyle(bgSliders[0]).getPropertyValue('--slider-duration-js'));
        const sliderDelay = 1000;
        const sliderAnimation = sldierDuration + sliderDelay;
        const sliderDelayInAction = sldierDuration + (sliderAnimation * 2);
  
        bgSliders.forEach(slider => {
          firstAction(slider);
          sliderInAction(slider, sliderDelayInAction); //1500 + 2500 + 2500 = 6500
        }); 
    
        function firstAction(slider) {
          let activeSlide = slider.firstElementChild
          let activeSlideClasses = activeSlide.dataset.classes.split(' ');
    
          activeSlide.classList.add('active');
    
          setTimeout(() => {
            if (activeSlideClasses[1]) {
              slider.classList.add(activeSlideClasses[0]);
            }
    
            activeSlide.classList.remove('active');
    
            setTimeout(() => {
              activeSlideClasses[1] ? slider.classList.add(activeSlideClasses[1]) : slider.classList.add(activeSlideClasses[0]);
              activeSlide.classList.add('active');
            }, sldierDuration)
          }, sliderAnimation);
          
        }
    
        function sliderInAction(slider, delay) {
          setTimeout(() => {
            let activeSlide = slider.querySelector('.active');
            let activeSlideClasses = activeSlide.dataset.classes.split(' ');
    
            let nextSlide = activeSlide.nextElementSibling === null ? slider.firstElementChild : activeSlide.nextElementSibling;
            let nextSlideClasses = nextSlide.dataset.classes.split(' ');
    
            slider.classList.remove(...activeSlideClasses);
    
            if (nextSlideClasses.length > 1) {
              sliderInActionPart(activeSlide, nextSlide, nextSlideClasses);
            } else {
              sliderInActionPart(activeSlide, nextSlide, nextSlideClasses);
            }
    
          }, delay);
    
          function sliderInActionPart(activeSlide, nextSlide, nextSlideClasses) {
            if (nextSlideClasses[1]) {
              slider.classList.add(nextSlideClasses[0]);
            }
            activeSlide.classList.remove('active');
    
            setTimeout(() => {
              nextSlideClasses[1] ? slider.classList.add(nextSlideClasses[1]) : slider.classList.add(nextSlideClasses[0]);
              nextSlide.classList.add('active');
    
              sliderInAction(slider, sliderAnimation);
            }, sldierDuration);
          }
        };
    
      };
    }
    
});
